<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "listing_site_provider_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ListingSiteProviderStats".
 *
 * Columns in table "listing_site_provider_stats" available as properties of the model,
 * followed by relations of table "listing_site_provider_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $listing_site_id
 * @property integer $account_id
 * @property integer $provider_id
 * @property string $date
 * @property integer $listings_reported_page_views
 * @property integer $reported_page_views
 * @property integer $reported_page_actions
 * @property integer $estimated
 * @property integer $maps_views
 * @property integer $search_views
 * @property integer $photo_views
 * @property integer $local_post_views
 * @property integer $website_actions
 * @property integer $phone_call_actions
 * @property integer $driving_direction_actions
 * @property integer $local_post_actions
 * @property string $date_added
 *
 * @property ListingSite $listingSite
 * @property Provider $provider
 * @property Account $account
 */
abstract class BaseListingSiteProviderStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'listing_site_provider_stats';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ListingSiteProviderStats|ListingSiteProviderStats', $n);
    }

    public static function representingColumn()
    {
        return 'date';
    }

    public function rules()
    {
        return array(
            array('listing_site_id, account_id, date, listings_reported_page_views, reported_page_views, reported_page_actions, date_added', 'required'),
            array('listing_site_id, account_id, provider_id, listings_reported_page_views, reported_page_views, reported_page_actions, estimated, maps_views, search_views, photo_views, local_post_views, website_actions, phone_call_actions, driving_direction_actions, local_post_actions', 'numerical', 'integerOnly'=>true),
            array('provider_id, estimated, maps_views, search_views, photo_views, local_post_views, website_actions, phone_call_actions, driving_direction_actions, local_post_actions', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, listing_site_id, account_id, provider_id, date, listings_reported_page_views, reported_page_views, reported_page_actions, estimated, maps_views, search_views, photo_views, local_post_views, website_actions, phone_call_actions, driving_direction_actions, local_post_actions, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'listingSite' => array(self::BELONGS_TO, 'ListingSite', 'listing_site_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'listing_site_id' => null,
            'account_id' => null,
            'provider_id' => null,
            'date' => Yii::t('app', 'Date'),
            'listings_reported_page_views' => Yii::t('app', 'Listings Reported Page Views'),
            'reported_page_views' => Yii::t('app', 'Reported Page Views'),
            'reported_page_actions' => Yii::t('app', 'Reported Page Actions'),
            'estimated' => Yii::t('app', 'Estimated'),
            'maps_views' => Yii::t('app', 'Maps Views'),
            'search_views' => Yii::t('app', 'Search Views'),
            'photo_views' => Yii::t('app', 'Photo Views'),
            'local_post_views' => Yii::t('app', 'Local Post Views'),
            'website_actions' => Yii::t('app', 'Website Actions'),
            'phone_call_actions' => Yii::t('app', 'Phone Call Actions'),
            'driving_direction_actions' => Yii::t('app', 'Driving Direction Actions'),
            'local_post_actions' => Yii::t('app', 'Local Post Actions'),
            'date_added' => Yii::t('app', 'Date Added'),
            'listingSite' => null,
            'provider' => null,
            'account' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('listing_site_id', $this->listing_site_id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('date', $this->date, true);
        $criteria->compare('listings_reported_page_views', $this->listings_reported_page_views);
        $criteria->compare('reported_page_views', $this->reported_page_views);
        $criteria->compare('reported_page_actions', $this->reported_page_actions);
        $criteria->compare('estimated', $this->estimated);
        $criteria->compare('maps_views', $this->maps_views);
        $criteria->compare('search_views', $this->search_views);
        $criteria->compare('photo_views', $this->photo_views);
        $criteria->compare('local_post_views', $this->local_post_views);
        $criteria->compare('website_actions', $this->website_actions);
        $criteria->compare('phone_call_actions', $this->phone_call_actions);
        $criteria->compare('driving_direction_actions', $this->driving_direction_actions);
        $criteria->compare('local_post_actions', $this->local_post_actions);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
